commit:     339801c88884b55db392e5cad59e3c881ac61e05
Author:     Mo Zhou <cdluminate <AT> gmail <DOT> com>
AuthorDate: Sun Sep  1 05:29:55 2019 +0000
Commit:     Benda XU <heroxbd <AT> gentoo <DOT> org>
CommitDate: Wed Sep  4 08:20:59 2019 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=339801c8

sci-libs/openblas: add new version 0.3.7

Closes: https://github.com/gentoo/gentoo/pull/12742

Signed-off-by: Mo Zhou <cdluminate <AT> gmail.com>
Signed-off-by: Benda Xu <heroxbd <AT> gentoo.org>

 sci-libs/openblas/Manifest              |   1 +
 sci-libs/openblas/openblas-0.3.7.ebuild | 127 ++++++++++++++++++++++++++++++++
 2 files changed, 128 insertions(+)

diff --git a/sci-libs/openblas/Manifest b/sci-libs/openblas/Manifest
index 380d03deca4..d1b62bde629 100644
--- a/sci-libs/openblas/Manifest
+++ b/sci-libs/openblas/Manifest
@@ -1 +1,2 @@
 DIST openblas-0.3.6.tar.gz 11923774 BLAKE2B 
0133b83a4449fd7f86d6379129be4e4477df338d0a402a7787eec317838922b175315c6e6b014a2c7ed6aa1c58509a28f6b48c641e043af067434c4315f1fdb1
 SHA512 
e432ae8bfbdc8e8c6336553e05181ab38576164c140ef2a6ddb2a66479f724bd4e60a2c90f7bc15bf18eefa7045e7775dedae421fb71296b8d250132c2407b07
+DIST openblas-0.3.7.tar.gz 11991860 BLAKE2B 
c4eebcbdda8c15ce384195bd2a57d3638b9a8fa9a0484dc3af9dcef0543e7bbfd8444b65ede36379f2182a9bd3df085070210d289c916dfa428da7ab6889eb43
 SHA512 
424d1c9c6fd97f6af4fdb7d7dce320cf5eab867a027e576531e39df934358736c4efab88782f781ec8f4afa8d992544040e3bbff3a4736c20cf4256d3a8e517d

diff --git a/sci-libs/openblas/openblas-0.3.7.ebuild 
b/sci-libs/openblas/openblas-0.3.7.ebuild
new file mode 100644
index 00000000000..f52bf5c6ece
--- /dev/null
+++ b/sci-libs/openblas/openblas-0.3.7.ebuild
@@ -0,0 +1,127 @@
+# Copyright 1999-2019 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+inherit fortran-2 toolchain-funcs
+
+DESCRIPTION="Optimized BLAS library based on GotoBLAS2"
+HOMEPAGE="http://xianyi.github.com/OpenBLAS/";
+SRC_URI="https://github.com/xianyi/OpenBLAS/tarball/v${PV} -> ${P}.tar.gz"
+
+LICENSE="BSD"
+SLOT="0"
+KEYWORDS="~amd64 ~x86 ~amd64-linux ~x86-linux ~x64-macos ~x86-macos"
+IUSE="dynamic eselect-ldso index-64bit openmp pthread"
+REQUIRED_USE="?? ( openmp pthread )"
+
+RDEPEND="
+       eselect-ldso? ( >=app-eselect/eselect-blas-0.2
+                       !app-eselect/eselect-cblas
+                       >=app-eselect/eselect-lapack-0.2 )"
+
+DEPEND="virtual/pkgconfig"
+
+PATCHES=( "${FILESDIR}/shared-blas-lapack.patch" )
+
+pkg_setup() {
+       fortran-2_pkg_setup
+       use openmp && tc-check-openmp
+       export CC=$(tc-getCC) FC=$(tc-getFC)
+
+       use dynamic && \
+               export DYNAMIC_ARCH=1 TARGET=GENERIC NUM_THREADS=64 
NO_AFFINITY=1
+
+       # disable submake with -j
+       export MAKE_NB_JOBS=-1
+
+       USE_THREAD=0
+       if use openmp; then
+               USE_THREAD=1; USE_OPENMP=1;
+       elif use pthread; then
+               USE_THREAD=1; USE_OPENMP=0;
+       fi
+       export USE_THREAD USE_OPENMP
+
+       export PREFIX="${EPREFIX}/usr"
+}
+
+src_unpack () {
+       default
+       mv "${WORKDIR}"/*OpenBLAS* "${S}" || die
+       if use index-64bit; then
+               cp -aL "${S}" "${S}-index-64bit" || die
+       fi
+}
+
+src_compile () {
+       emake
+       emake -Cinterface shared-blas-lapack
+       if use index-64bit; then
+               emake -C"${S}-index-64bit" INTERFACE64=1 LIBPREFIX=libopenblas64
+       fi
+}
+
+src_test() {
+       emake tests
+}
+
+src_install () {
+       emake install DESTDIR="${D}" 
OPENBLAS_INCLUDE_DIR='$(PREFIX)'/include/${PN} \
+               OPENBLAS_LIBRARY_DIR='$(PREFIX)'/$(get_libdir)
+       dodoc GotoBLAS_*.txt *.md Changelog.txt
+
+       if use eselect-ldso; then
+               dodir /usr/$(get_libdir)/blas/openblas/
+               insinto /usr/$(get_libdir)/blas/openblas/
+               doins interface/libblas.so.3
+               dosym libblas.so.3 usr/$(get_libdir)/blas/openblas/libblas.so
+               doins interface/libcblas.so.3
+               dosym libcblas.so.3 usr/$(get_libdir)/blas/openblas/libcblas.so
+
+               dodir /usr/$(get_libdir)/lapack/openblas/
+               insinto /usr/$(get_libdir)/lapack/openblas/
+               doins interface/liblapack.so.3
+               dosym liblapack.so.3 
usr/$(get_libdir)/lapack/openblas/liblapack.so
+       fi
+
+       if use index-64bit; then
+               insinto /usr/$(get_libdir)/
+               dolib.so "${S}-index-64bit"/libopenblas64*.so*
+       fi
+}
+
+pkg_postinst () {
+       use eselect-ldso || return
+       local libdir=$(get_libdir) me="openblas"
+
+       # check blas
+       eselect blas add ${libdir} "${EROOT}"/usr/${libdir}/blas/${me} ${me}
+       local current_blas=$(eselect blas show ${libdir} | cut -d' ' -f2)
+       if [[ ${current_blas} == "${me}" || -z ${current_blas} ]]; then
+               eselect blas set ${libdir} ${me}
+               elog "Current eselect: BLAS/CBLAS ($libdir) -> 
[${current_blas}]."
+       else
+               elog "Current eselect: BLAS/CBLAS ($libdir) -> 
[${current_blas}]."
+               elog "To use blas [${me}] implementation, you have to issue (as 
root):"
+               elog "\t eselect blas set ${libdir} ${me}"
+       fi
+
+       # check lapack
+       eselect lapack add ${libdir} "${EROOT}"/usr/${libdir}/lapack/${me} ${me}
+       local current_lapack=$(eselect lapack show ${libdir} | cut -d' ' -f2)
+       if [[ ${current_lapack} == "${me}" || -z ${current_lapack} ]]; then
+               eselect lapack set ${libdir} ${me}
+               elog "Current eselect: LAPACK ($libdir) -> [${current_lapack}]."
+       else
+               elog "Current eselect: LAPACK ($libdir) -> [${current_lapack}]."
+               elog "To use lapack [${me}] implementation, you have to issue 
(as root):"
+               elog "\t eselect lapack set ${libdir} ${me}"
+       fi
+}
+
+pkg_postrm () {
+       if use eselect-ldso; then
+               eselect blas validate
+               eselect lapack validate
+       fi
+}

Reply via email to